package com.energy.online.data.common;

import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.ConcurrentHashMap;

@Slf4j
public class CommonData {

    public static final Map<Integer, Object> map = new ConcurrentHashMap<>();

    public static final List<Map<Integer, Object>> list = new ArrayList<>();

    public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    public static void addList() {
        // -1 表示时间
//        log.info("数据长度(包含时间):" + map.size());
        if (!map.isEmpty()) {
            String nowTime = sdf.format(System.currentTimeMillis());
            map.put(0, nowTime);
            list.add(new TreeMap<>(map));
        }
    }

    public static void put(Integer key, Object value) {
        map.put(key, value);
    }

    public static List<Map<Integer, Object>> getListAndClean() {
        int index = list.size() - 1;
        for (int i = list.size() - 1; i >= 0; i--) {
            if (String.valueOf(list.get(i).get(0)).endsWith("9:50") || String.valueOf(list.get(i).get(0)).endsWith("9:59")) {
                index = i;
                break;
            }
        }

        List<Map<Integer, Object>> nowList = new ArrayList<>(list.subList(0, index + 1));
        list.subList(0, index + 1).clear();
        return nowList;
    }

    public static void main(String[] args) throws InterruptedException {
        put(1, 2);
        for (int j = 0; j < 3; j++) {
            for (int i = 0; i < 60; i++) {
                addList();
                Thread.sleep(1000);
            }
            for (Map<Integer, Object> entry : getListAndClean()) {
                System.out.println(entry);
            }
            System.out.println("----------------------------------");
            for (Map<Integer, Object> entry : list) {
                System.out.println(entry);
            }
            System.out.println("**************************************");
        }
    }
}
